var slickPosToLayoutName = ['0', '1', '2', '3', '11', '12', '4', '5', '6', '7', '8', '13', '9', '10'];
var arrSuggestion = [];
var showClockRadioButtonList = [
  { label: 'Yes', name: 'showClock', value: 1 },
  { label: 'No', name: 'showClock', value: 0 },
];
var propertiesResponse = null;

$(document).ready(async function () {

  initTooltips();
  initServiceId();

  const textType = '#weatherTextType';

  // Change font select (file manager) after close modal
  $('body').off('hide.bs.modal').on('hide.bs.modal', '#fileManagerModal', function () {
    createFontList(textType, serviceArrTmp[activeItem].font);
  });

  const locationName = $('#weatherLocationName');
  locationName.on('change', function () {
    validate($(this), '', 'Enter a city name.');
  });
  locationName.typeahead({
    showHintOnFocus: true,
    minLength: 1,
    items: 'all',
    autoSelect: true,
    theme: 'bootstrap4',
    source: getLocationDataToSuggest,
    updater: function (item) {
      city = item.split(',');
      administrativeArea = city[1].trim();
      for (let i = 0; i < arrSuggestion.length; i++) {
        if (arrSuggestion[i].LocalizedName === city[0] && arrSuggestion[i].AdministrativeArea.LocalizedName === administrativeArea) {
          serviceArrTmp[activeItem].location = arrSuggestion[i].Key;
          serviceArrTmp[activeItem].locationName = arrSuggestion[i].LocalizedName;
          renderMap();
          return arrSuggestion[i].LocalizedName;
        }
      }
    }
  });

  $('.chooseBgColor').on('click', function () {
    $('.chooseBgColor').css('border-color', 'transparent');
    var colorValueOfButtonStart = $(this).attr('data-value-start');
    var colorValueOfButtonEnd = $(this).attr('data-value-end');
    $('.chooseBgColor[data-value-start="' + colorValueOfButtonStart + '"]').css('border-color', '#508cff');
    $('#bgStartColor').val(colorValueOfButtonStart);
    $('#bgEndColor').val(colorValueOfButtonEnd);
    return false;
  });

  $('#weatherLayout').slick({
    centerMode: true,
    centerPadding: '60px',
    slidesToShow: 1,
    variableWidth: true,
    draggable: false
  });

  // Fill form

  $('#weatherCustomName')
    .val(serviceArrTmp[activeItem].customName || '')
    .keyup(onCustomNameKeyUp)
    .attachValidation({
      pattern: '^[A-Za-z0-9 -]{0,}$',
      invalidMsg: 'Only chars A-Z, a-z, 0-9, white space and dash are allowed.'
    });
  locationName.val(serviceArrTmp[activeItem].locationName);
  $('#weatherTitle').val(serviceArrTmp[activeItem].title != undefined ? serviceArrTmp[activeItem].title : '');

  if (serviceArrTmp[activeItem].clockType != undefined) {
    const clockRadioList = [
      { label: '12h', name: 'radioClock', value: '12h' },
      { label: '24h', name: 'radioClock', value: '24h' },
    ];
    const weatherClockRadioButtons = new RadioButtons();
    await weatherClockRadioButtons.create('#weatherRadioClockContainer', true, true, clockRadioList, serviceArrTmp[activeItem].clockType);
  }

  $('#bgStartColor').val(serviceArrTmp[activeItem].bgStartColor);
  $('#bgEndColor').val(serviceArrTmp[activeItem].bgEndColor);
  var bgStartColor = $('#bgStartColor').val();
  $('.chooseBgColor[data-value-start="' + bgStartColor + '"]').css('border-color', '#508cff');

  const languageVal = serviceArrTmp[activeItem].lang;
  $('#weatherLanguage').val(languageVal);

  createFontList(textType, serviceArrTmp[activeItem].font);

  const unitsRadioList = [
    { label: 'Metric', name: 'radioUnits', value: 'Metric' },
    { label: 'Imperial', name: 'radioUnits', value: 'Imperial' },
  ];
  const weatherUnitsRadioButtons = new RadioButtons();
  await weatherUnitsRadioButtons.create('#weatherUnitsContainer', true, true, unitsRadioList, serviceArrTmp[activeItem].units);

  $('#weatherOffsetX').val(serviceArrTmp[activeItem].pos_x);
  $('#weatherOffsetY').val(serviceArrTmp[activeItem].pos_y);
  $('#weatherScale').val(serviceArrTmp[activeItem].scale * 100);

  // Find slick position
  for (var i = 0; i < slickPosToLayoutName.length; i++) {
    if (slickPosToLayoutName[i] == serviceArrTmp[activeItem].layout) {
      $('#weatherLayout').slick('slickGoTo', i);
      break;
    }
  }

  initLayerZindex(serviceArrTmp[activeItem].zIndex || 0);

  // Validate lcoation after form is filled
  validate(locationName, '', 'Enter a city name.');
  const resolutionId = '#weatherResolution';
  const videoChannelId = '#weatherVideoChannel';
  const videoPreviewSelectId = '#accuweatherPreviewVideoChannel';
  createResolutionList(resolutionId);
  onResolutionChange(resolutionId, videoChannelId);
  createPositionList('#weatherPosition', serviceArrTmp[activeItem].coordSystem);
  await createTriggeringElement('#weatherAutomationTypeContainer', serviceArrTmp[activeItem].automationType, serviceArrTmp[activeItem].schedule, false);
  onVideoChannelChange(resolutionId, videoChannelId, videoPreviewSelectId);
  await createVideoChannelElement(videoChannelId, serviceArrTmp[activeItem].cameraList);
  onPreviewVideoChannelChange(videoPreviewSelectId, resolutionId);

  // Callbacks for changes
  $('.chooseBgColor').on('click', formChangedCallback); //div with color onclick
  locationName.on('change', formChangedCallback);
  $('.form-control').change(formChangedCallback);
  $('.form-control-inline').change(formChangedCallback);
  $('#weatherLayout').on('beforeChange', layoutChangedCallback);
  $('.layoutItem').click(layoutClickedCallback);
  $('.fontManagerBtn').click(showFontManagerCallback);

  formChangedCallback();

  let currentCameraResolutionObject = cameraResolutions[parseInt($('#weatherResolution').val())];
  showImageFromCamera('imagePreviewCamera', currentCameraResolutionObject, $(videoPreviewSelectId).val());

  createScheduleBtn();

});

async function formChangedCallback() {
  serviceArrTmp[activeItem].customName = $('#weatherCustomName').val();
  serviceArrTmp[activeItem].title = $('#weatherTitle').val();
  serviceArrTmp[activeItem].clockType = $('#weatherRadioClockContainer input[type="radio"]:checked').val();
  serviceArrTmp[activeItem].lang = $('#weatherLanguage').val();
  serviceArrTmp[activeItem].font = $('#weatherTextType').val();
  serviceArrTmp[activeItem].bgStartColor = $('#bgStartColor').val();
  serviceArrTmp[activeItem].bgEndColor = $('#bgEndColor').val();
  serviceArrTmp[activeItem].locationName = $('#weatherLocationName').val();
  serviceArrTmp[activeItem].units = $('#weatherUnitsContainer input[type="radio"]:checked').val();
  let currentCameraResolutionObject = cameraResolutions[parseInt($('#weatherResolution').val())];
  serviceArrTmp[activeItem].width = currentCameraResolutionObject.width;
  serviceArrTmp[activeItem].height = currentCameraResolutionObject.height;
  await saveLayerZindex($('#layerZindex').val());
  serviceArrTmp[activeItem].coordSystem = $('#weatherPosition').val();
  serviceArrTmp[activeItem].automationType = $('#weatherAutomationTypeContainer input[type="radio"]:checked').val();
  serviceArrTmp[activeItem].pos_x = parseInt($('#weatherOffsetX').val());
  serviceArrTmp[activeItem].pos_y = parseInt($('#weatherOffsetY').val());
  serviceArrTmp[activeItem].scale = parseFloat($('#weatherScale').val()) / 100;
  serviceArrTmp[activeItem].cameraList = getSelectedVideoChannelValues($('#weatherVideoChannel'));
  showSaveWarning();
}

function layoutChangedCallback(event, slick, currentSlide, nextSlide) {
  serviceArrTmp[activeItem].layout = slickPosToLayoutName[nextSlide];
  showSaveWarning();
}

function layoutClickedCallback(event) {
  var targ = event.target || event.srcElement;
  var item = $(targ).closest('.layoutItem');
  var current = $('#weatherLayout').slick('slickCurrentSlide');
  var newPos = item.attr('data-slick-index');
  if (current == newPos)
    return;

  if (current < newPos)
    $('#weatherLayout').slick('slickNext');
  else
    $('#weatherLayout').slick('slickPrev');
}

async function getLocationDataToSuggest(query, result) {
  let lang = serviceArrTmp[activeItem].lang;
  while (arrSuggestion.length > 0) {
    arrSuggestion.pop();
  }

  let data;
  try {
    data = await serverApi.getSuggestedMapLocation(cameraParams.getServerUrl(), cameraParams.getSerialNumber(), query, lang);

  } catch (error) {
    throw new Error(error.message);
  }

  result(
    data.map((item) => {
      arrSuggestion.push(item);
      return `${item.LocalizedName}, ${item.AdministrativeArea.LocalizedName}, ${item.Country.LocalizedName}`;
    })
  );
}

