class CheckboxSwitch {

  element = null;
  toggle = null;
  label = null;

  /**
   * Render html container with input
   */
  render() {
    const label_html = document.createElement('label');
    label_html.className = 'checkbox_switch';
    const span_html = document.createElement('span');
    span_html.className = 'slider round';
    label_html.appendChild(span_html);
    this.element.appendChild(label_html);
  }

  /**
   * @param {boolean} value
   */
  setValue(value) {
    this.toggle.setAttribute('checked', Boolean(value));
  }

  /**
   * @param {string} elementId
   * @param {number} defaultValue
   * @param onChangeCallback
   */
  create(elementId, defaultValue, onChangeCallback) {

    this.element = $(elementId)[0];
    this.render();

    this.toggle = this.element.getElementsByTagName('label')[0];
    this.label = $(this.toggle).closest('.input-group').find('label.control-label')[0];

    this.toggle.removeEventListener('click', () => {});
    this.toggle.addEventListener('click', () => {
      this.toggleClickCallback(onChangeCallback);
    });
    this.label.removeEventListener('click', () => {});
    this.label.addEventListener('click', () => {
      this.toggleClickCallback(onChangeCallback);
    });

    this.setValue(defaultValue);
  }

  toggleClickCallback(onChangeCallback) {
    const checked = parseBool(this.toggle.getAttribute('checked'));
    this.setValue(!checked);
    onChangeCallback();
  }

}