class RadioButtons {

  containerDivElement = null;

  newInput (name, label, value, isInline, isWithoutBorder) {
    let newRadioOption = `<div class="btn btn-radio %REPLACE_BORDER% btn-sm %REPLACE_BTN%"><div class="custom-control custom-radio">
                            <input type="radio" id="%REPLACE_NAME%-%REPLACE_VALUE%" name="%REPLACE_NAME%" value="%REPLACE_VALUE%" class="custom-control-input form-control">
                            <label class="custom-control-label" for="%REPLACE_NAME%-%REPLACE_VALUE%">%REPLACE_LABEL%</label>
                        </div></div>`;
    newRadioOption = newRadioOption.replaceAll('%REPLACE_BORDER%', isWithoutBorder ? 'btn-without-border' : '');
    newRadioOption = newRadioOption.replaceAll('%REPLACE_BTN%', isInline ? 'd-inline-flex mr-1' : 'd-flex mb-1');
    newRadioOption = newRadioOption.replaceAll('%REPLACE_NAME%', name);
    newRadioOption = newRadioOption.replaceAll('%REPLACE_LABEL%', label);
    newRadioOption = newRadioOption.replaceAll('%REPLACE_VALUE%', value);
    return newRadioOption;
  }

  async create (containerIdentificator, isInline, isWithoutBorder, radioList, defaultValue) {
    this.containerDivElement = $(containerIdentificator);
    this.containerDivElement.addClass('radioButtonsContainer');

    let htmlRadios = [];
    radioList.forEach((item, index) => {
      let new_radio = this.newInput(item.name, item.label, item.value, isInline, isWithoutBorder);
      htmlRadios.push(new_radio);
    });
    this.containerDivElement.append(htmlRadios.join(""));

    let radioButton = this.containerDivElement.find('input[type="radio"][value="' + defaultValue + '"]');
    if (radioButton.length !== 1) {
      radioButton = this.containerDivElement.find('input[type="radio"]:first');
    }
    radioButton.closest('.btn-radio').addClass('checked');
    radioButton.attr('checked', 'checked');

    const radiosElementList = this.containerDivElement.find('.btn-radio');
    radiosElementList.off('click').on('click', function () {
      radiosElementList.removeClass('checked');
      radiosElementList.find('input[type="radio"]').removeAttr('checked');
      $(this).addClass('checked');
      $(this).find('input[type="radio"]').attr('checked', 'checked').change();
    });
  }

}