var arrSuggestion = [];

$(document).ready(async function () {

  //init tooltips
  initTooltips();
  initServiceId();

  // Change font select & image select (file manager) after close modal
  $('body').off('hide.bs.modal').on('hide.bs.modal', '#fileManagerModal', function () {
    createFontList('#infotickerTextType', serviceArrTmp[activeItem].font);
    createImageList('#customImage', true, serviceArrTmp[activeItem].image);
  });

  const locationName = $('#infotickerLocationName');
  locationName.on('change', function () {
    validate($(this), '', 'Enter a city name.');
  });
  locationName.typeahead({
    showHintOnFocus: true,
    minLength: 1,
    items: 'all',
    autoSelect: true,
    theme: 'bootstrap4',
    source: getLocationDataToSuggest,
    updater: function (item) {
      city = item.split(',');
      administrativeArea = city[1].trim();
      for (let i = 0; i < arrSuggestion.length; i++) {
        if (arrSuggestion[i].LocalizedName === city[0] && arrSuggestion[i].AdministrativeArea.LocalizedName === administrativeArea) {
          serviceArrTmp[activeItem].weatherLocation = arrSuggestion[i].Key;
          serviceArrTmp[activeItem].weatherLocationName = arrSuggestion[i].LocalizedName;
          renderMap();
          return arrSuggestion[i].LocalizedName;
        }
      }
    }
  });

  $('#infotickerSourceType').on('change', function () {
    var infotickerSourceTypeValue = $(this).val();
    if (infotickerSourceTypeValue === 'text') {
      $('#infotickerSource-text').show();
      $('#infotickerSource').attr('placeholder', 'Use Enter to break the line');
    } else {
      $('#infotickerSource-text').hide();
      $('#infotickerSource').attr('placeholder', 'Use UTF coding in TXT file.');
    }
  });

  $('#colorPaletteForTextColor').on('change', function () {
    var color = $(this).val();
    $('#infotickerTextColor').val(color);
  });

  $('#infotickerTextColor').on('change', function () {
    var color = $(this).val();
    $('#colorPaletteForTextColor').val(color);
  });

  $('#colorPaletteForBgColor').on('change', function () {
    var color = $(this).val();
    $('#infotickerBgColor').val(color);
  });

  $('#infotickerBgColor').on('change', function () {
    var color = $(this).val();
    $('#colorPaletteForBgColor').val(color);
  });

  $('.infotickerCrawlLeft').show();
  $('#infotickerCrawlLeft').on('change', function () {
    var infotickerCrawlLeftValue = $(this).val();
    if (infotickerCrawlLeftValue === "No") {
      $('#infotickerSwitchingTime').prop('disabled', false);
      $('#infotickerNumberOfLines').prop('disabled', false);
    } else {
      $('#infotickerSwitchingTime').prop('disabled', true);
      $('#infotickerNumberOfLines').val(1);
      $('#infotickerNumberOfLines').prop('disabled', true);
    }
  });

  // Fill form
  initLayerZindex(serviceArrTmp[activeItem].zIndex || 0);

  $('#infotickerCustomName')
    .val(serviceArrTmp[activeItem].customName || '')
    .keyup(onCustomNameKeyUp)
    .attachValidation({
      pattern: '^[A-Za-z0-9 -]{0,}$',
      invalidMsg: 'Only chars A-Z, a-z, 0-9, white space and dash are allowed.'
    });
  locationName.val(serviceArrTmp[activeItem].weatherLocationName);

  const positionRadioButtonList = [
    { label: 'Top', name: 'positionButton', value: 'top' },
    { label: 'Bottom', name: 'positionButton', value: 'bottom' },
  ];
  const positionRadioButtons = new RadioButtons();
  await positionRadioButtons.create('#infotickerPositionContainer', true, true, positionRadioButtonList, serviceArrTmp[activeItem].coordSystem || 'bottom');

  $('#infotickerPosY').val(convertFloatToPercentage(serviceArrTmp[activeItem].pos_y || 0.05));

  const showClockCheckbox = new CheckboxSwitch();
  showClockCheckbox.create('#infotickerShowClockContainer', serviceArrTmp[activeItem].showClock, () => {
    onChangeShowClockContainer();
    formChangedCallback();
  });

  if (serviceArrTmp[activeItem].clockType != undefined) {
    const clockRadioList = [
      { label: '12h', name: 'radioClock', value: '12h' },
      { label: '24h', name: 'radioClock', value: '24h' },
    ];
    const clockRadioButtons = new RadioButtons();
    await clockRadioButtons.create('#infotickerRadioClockContainer', true, true, clockRadioList, serviceArrTmp[activeItem].clockType);
  }

  onChangeShowClockContainer();

  if (serviceArrTmp[activeItem].textColor != "" && serviceArrTmp[activeItem].textColor != undefined) {
    var textColor = rgbToHex(serviceArrTmp[activeItem].textColor);
    $('#infotickerTextColor').val(textColor);
    $('#colorPaletteForTextColor').val(textColor);
  }
  let infotickerBgOpacity = $('#infotickerBgOpacity');
  if (serviceArrTmp[activeItem].bgColor != "" && serviceArrTmp[activeItem].bgColor != undefined) {
    var bgColor = rgbToHex(serviceArrTmp[activeItem].bgColor);
    let bgOpacity = getOpacity(serviceArrTmp[activeItem].bgColor);
    $('#infotickerBgColor').val(bgColor);
    $('#colorPaletteForBgColor').val(bgColor);
    infotickerBgOpacity.val(bgOpacity);
  }
  // Opacity input change text with %
  infotickerBgOpacity.next().find('.input-group-text').first().text(infotickerBgOpacity.val());
  infotickerBgOpacity.on('change mousemove', function () {
    $(this).next().find('.input-group-text').first().text($(this).val());
  });

  if (serviceArrTmp[activeItem].sourceType == "") {
    $('#infotickerSourceType').val('text').change();
  } else {
    $('#infotickerSourceType').val(serviceArrTmp[activeItem].sourceType).change();
  }
  if (serviceArrTmp[activeItem].sourceType === 'text') {
    $('#infotickerSource-text').show();
  }
  $('#infotickerSource').val(serviceArrTmp[activeItem].source);
  createFontList('#infotickerTextType', serviceArrTmp[activeItem].font);
  $('#infotickerFontSize').val(parseInt(serviceArrTmp[activeItem].fontSize));
  $('#infotickerLanguage').val(serviceArrTmp[activeItem].weatherLang);
  $('#infotickerUnits').val(serviceArrTmp[activeItem].weatherUnits);
  const unitsRadioList = [
    { label: 'Metric', name: 'radioUnits', value: 'Metric' },
    { label: 'Imperial', name: 'radioUnits', value: 'Imperial' },
  ];
  const unitsRadioButtons = new RadioButtons();
  await unitsRadioButtons.create('#infotickerUnitsContainer', true, true, unitsRadioList, serviceArrTmp[activeItem].weatherUnits)

  $('#infotickerSwitchingTime').val(serviceArrTmp[activeItem].switchingTime);

  //if yes, disable switchingTime and NumberOfLines
  if (!serviceArrTmp[activeItem].crawlLeft) {
    $('#infotickerCrawlLeft').val("No");
    $('#infotickerSwitchingTime').prop('disabled', false);
    $('#infotickerNumberOfLines').prop('disabled', false);
  } else {
    $('#infotickerSwitchingTime').prop('disabled', true);
    $('#infotickerNumberOfLines').val(1);
    $('#infotickerNumberOfLines').prop('disabled', true);
    const covert_speed_to_value = {
      1: "Slow",
      2: "Medium",
      4: "Fast",
    };
    const unknown_speed = covert_speed_to_value[serviceArrTmp[activeItem].crawlSpeed] == undefined;
    if (unknown_speed) {
      throw Error('Unknown speed of crawl left.');
    }
    $('#infotickerCrawlLeft').val(covert_speed_to_value[serviceArrTmp[activeItem].crawlSpeed]);
  }

  $('#infotickerNumberOfLines').val(serviceArrTmp[activeItem].numberOfLines);

  // Validate location after form is filled
  validate(locationName, '', 'Enter a city name.');

  const resolutionId = '#infotickerResolution';
  const videoChannelId = '#infotickerVideoChannel';
  const videoPreviewSelectId = '#infotickerPreviewVideoChannel';
  createResolutionList(resolutionId);
  onResolutionChange(resolutionId, videoChannelId);
  await createTriggeringElement('#infotickerAutomationTypeContainer', serviceArrTmp[activeItem].automationType, serviceArrTmp[activeItem].schedule, false);
  onVideoChannelChange(resolutionId, videoChannelId, videoPreviewSelectId);
  await createVideoChannelElement(videoChannelId, serviceArrTmp[activeItem].cameraList);
  onPreviewVideoChannelChange(videoPreviewSelectId, resolutionId);

  // Callbacks for changes
  locationName.on('change', formChangedCallback);
  $('.form-control, .form-control-inline').change(formChangedCallback);
  $('.form-control-inline').change(formChangedCallback);
  $('.fontManagerBtn').click(showFontManagerCallback);

  formChangedCallback();

  let currentCameraResolutionObject = cameraResolutions[parseInt($('#infotickerResolution').val())];
  showImageFromCamera('imagePreviewCamera', currentCameraResolutionObject, $(videoPreviewSelectId).val());

  createScheduleBtn();
});

function onChangeShowClockContainer() {
  const showClock = $('#infotickerShowClockContainer .checkbox_switch[checked="true"]').length === 1;
  $('.clockFormatRow').toggle(showClock);
}

async function formChangedCallback() {
  serviceArrTmp[activeItem].customName = $('#infotickerCustomName').val();
  serviceArrTmp[activeItem].showClock = $('#infotickerShowClockContainer .checkbox_switch[checked="true"]').length === 1 ? 1 : 0;
  serviceArrTmp[activeItem].clockType = $('#infotickerRadioClockContainer input[type="radio"]:checked').val();
  serviceArrTmp[activeItem].textColor = hexToRgb($('#infotickerTextColor').val());
  let bgColor = hexToRgb($('#infotickerBgColor').val());
  let bgOpacity = $('#infotickerBgOpacity').val();
  serviceArrTmp[activeItem].bgColor = getBgColor(bgColor, bgOpacity);
  serviceArrTmp[activeItem].weatherLang = $('#infotickerLanguage').val();
  serviceArrTmp[activeItem].weatherLocationName = $('#infotickerLocationName').val();
  serviceArrTmp[activeItem].sourceType = $('#infotickerSourceType').val();
  serviceArrTmp[activeItem].font = $('#infotickerTextType').val();
  serviceArrTmp[activeItem].fontSize = parseInt($('#infotickerFontSize').val());
  serviceArrTmp[activeItem].source = $('#infotickerSource').val();
  serviceArrTmp[activeItem].numberOfLines = parseInt($('#infotickerNumberOfLines').val());
  serviceArrTmp[activeItem].switchingTime = parseInt($('#infotickerSwitchingTime').val());

  let infoTickerCrawlLeftValue = $('#infotickerCrawlLeft').val();
  const crawl_left_on = infoTickerCrawlLeftValue !== "No";
  serviceArrTmp[activeItem].crawlLeft = crawl_left_on;
  if (crawl_left_on) {
    const covert_value_to_speed = {
      "Slow": 1,
      "Medium": 2,
      "Fast": 4,
    };
    const unknown_value = covert_value_to_speed[infoTickerCrawlLeftValue] == undefined;
    if (unknown_value) {
      throw Error('Unknown value of crawl left.');
    }
    serviceArrTmp[activeItem].crawlSpeed = covert_value_to_speed[infoTickerCrawlLeftValue];
  }

  serviceArrTmp[activeItem].weatherUnits = $('#infotickerUnitsContainer input[type="radio"]:checked').val();
  serviceArrTmp[activeItem].automationType = $('#infotickerAutomationTypeContainer input[type="radio"]:checked').val();
  let currentCameraResolutionObject = cameraResolutions[parseInt($('#infotickerResolution').val())];
  serviceArrTmp[activeItem].width = currentCameraResolutionObject.width;
  serviceArrTmp[activeItem].height = currentCameraResolutionObject.height;
  await saveLayerZindex($('#layerZindex').val());
  serviceArrTmp[activeItem].coordSystem = $('#infotickerPositionContainer input[type="radio"]:checked').val();
  serviceArrTmp[activeItem].pos_y = convertPercentageToFloat($('#infotickerPosY').val(), 5);
  serviceArrTmp[activeItem].cameraList = getSelectedVideoChannelValues($('#infotickerVideoChannel'));

  showSaveWarning();
}

/**
 *
 * @param color - rgba format
 * @returns {number} - opacity (0-100)
 */
function getOpacity(color) {
  let colorArr = color.split(",");
  return colorArr[3] * 100;
}

/**
 *
 * @param color - rgba format
 * @param opacity - interval 0-100
 * @returns {string} - rgba format
 */
function getBgColor(color, opacity) {
  color = color.split(",");
  color.pop();
  opacity = opacity / 100;
  color.push(opacity);
  return color.join(",");
}

async function getLocationDataToSuggest(query, result) {
  let lang = serviceArrTmp[activeItem].weatherLang;
  while (arrSuggestion.length > 0) {
    arrSuggestion.pop();
  }

  let data;
  try {
    data = await serverApi.getSuggestedMapLocation(cameraParams.getServerUrl(), cameraParams.getSerialNumber(), query, lang);

  } catch (error) {
    throw new Error(error.message);
  }

  result(
    data.map((item) => {
      arrSuggestion.push(item);
      return `${item.LocalizedName}, ${item.AdministrativeArea.LocalizedName}, ${item.Country.LocalizedName}`;
    })
  );
}


