const Configuration = () => {

  const getEnabledServices = () => {
    return serviceArrTmp.filter((service) => service.enabled === 1).length;
  }

  const getEnabledServicesPerChannel = () => {
    return serviceArrTmp.filter(
      (service) =>
        service.enabled === 1
        && JSON.stringify(serviceArrTmp[activeItem].cameraList.sort()) === JSON.stringify(service.cameraList.sort())
    ).length;
  }

  const config_ui_messages = {
    maxAllowedMessage: 'The maximum recommended number of overlay graphics for one video channel is 4. And a maximum of 8 created overlay graphics in total. It can differ per camera model and processor.',
    canAddNewService: 'Three or four active services in one Video Channel in CamOverlay App could be in conflict with Axis overlay.',
  }

  const getMaxAllowedMessage = async () => {
    return config_ui_messages.maxAllowedMessage
  }

  const getAddNewServiceMessage = async () => {
    return config_ui_messages.canAddNewService;
  }

  const exceedsMaxServiceCount = async () => {
    const enabled_services_count = getEnabledServices();
    const enabled_services_per_video_channel = getEnabledServicesPerChannel();

    if (enabled_services_count > 8 || enabled_services_per_video_channel > 4) {
      return true;
    }
    return false;
  }

  const canEnableAnotherService = async () => {
    const enabled_services_count = getEnabledServices();
    const enabled_services_per_video_channel = getEnabledServicesPerChannel();

    if (enabled_services_count >= 8 || enabled_services_per_video_channel >= 4) {
      return false;
    }
    return true;
  }

  const canAddNewService = async () => {
    const enabled_services_count = getEnabledServices();

    if (enabled_services_count === 2 || enabled_services_count === 3) {
      return false;
    }
    return true;
  }

  return {
    canEnableAnotherService,
    exceedsMaxServiceCount,
    getMaxAllowedMessage,
    canAddNewService,
    getAddNewServiceMessage,
  }
}