function ImageManager(app_name) {
  const image_options = {
    identifier: 'image',
    modalTitle: 'Image Manager',
    api: {
      getStorageUrl: () => camOverlayApi.getImageStorage(),
      listUrl: () => camOverlayApi.getImageList(),
      uploadUrl: (payload) => camOverlayApi.uploadImage(payload),
      removeUrl: (params) => camOverlayApi.removeImage(params),
    },
    listFileContainerWith: 'col-lg-8',
    filesAllowedTypes: ['jpg', 'jpeg', 'png', 'gif'],
    maxUrlLength: 1000,
    messages: {
      storageInfo: {
        flash: 'Images will be saved in camera internal memory. %ALLOWED_FILES%',
        SD0: 'Images will be saved on SD card inserted in camera. %ALLOWED_FILES%',
      },
      emptyRow: 'No images uploaded.',
      filesAllowed: 'Only PNG, JPG (JPEG) or GIF images are allowed.',
      urlFile: 'Invalid url, protocol required (ftp, file, http, https).',
      urlName: 'Empty name is invalid.',
      urlToLong: 'Too long URL, max length is 1000 chars.',
      urlToShort: 'Empty URL is invalid.',
      ftpTooltip: 'Insert a link (ftp://...) to your image.',
      sambaTooltip: 'Insert a path to your image in camera Network storage.',
      urlTooltip: 'Insert a link (http://...) to your image.',
      labelFileInputTooltip: 'Select the suitable storage. „Internal Memory“ = internal camera storage, „SD card“ = edge camera storage,' +
        ' „URL“ = links to external servers or directories.',
    },
  }

  /**
   * @param {string} removed_file_path
   */
  image_options.onAfterRemoveFile = function (removed_file_path) {};

  image_options.onAfterStorageChanged = function() {};

  image_options.onAfterCreateFileList = function() {};

  image_options.showGalleryAlert = function() {};

  return FileManager(app_name, image_options);
}